import java.util.Arrays;
import java.util.List;
import java.util.function.Function;
import java.util.function.IntUnaryOperator;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class Gyakorlat {
	public static void main(String[] args) {
		feladat5(args);
//		feladat10(args);
	}
	
	
	Function<Integer, Integer> fib2 =
//			n -> n == 1 ? 1 : n == 2 : 1 ? fib2.apply(n-1) + fib2.apply(n-2);
			n -> n == 1 ? 1 : n == 2 ? 1 :
				this.fib2.apply(n-1) + this.fib2.apply(n-2);

	final static Function<Integer, Integer> fib3 =
			n -> n == 1 ? 1 : n == 2 ? 1 :
				Gyakorlat.fib3.apply(n-1) + Gyakorlat.fib3.apply(n-2);
					
	private static void feladat5(String[] args) {
		Function<Integer, Integer> fib1 = new Function<>() {
			@Override
			public Integer apply(Integer n) {
				if (n == 1)   return 1;
				if (n == 2)   return 1;
				return this.apply(n-1) + apply(n-2);
			}
		};

		System.out.println(fib1.apply(8));
		System.out.println(new Gyakorlat().fib2.apply(8));
		System.out.println(fib3.apply(8));
	}


	public static void feladat10(String[] args) {
		// Készíts olyan lambdát, amely egy Supplier-t kap,
		// és önmaga is Supplier:
		// először a “belső” Supplier első elemét,
		// aztán az első két elemét, aztán az első három elemét stb.
		// adja ki.

//		1,2,3,4,5,6,7,8,9,10,...
//		[1],[2,3],[4,5,6],[7,8,9,10],...
	
		Function<Supplier<Integer>, Supplier<int[]>> f10 = new Function<Supplier<Integer>, Supplier<int[]>>() {
			int outputLenCount = 1;
			
			@Override
			public Supplier<int[]> apply(Supplier<Integer> supp) {
				return () -> {
					int[] result = new int[outputLenCount];
					for (int i = 0; i < outputLenCount; i++) {
						result[i] = supp.get();
					}
	
					++outputLenCount;
	
					return result;
				};
			}
		};

		Function<Supplier<Integer>, Supplier<int[]>> f10v2 =
			supp -> new Supplier<>() {
				int outputLenCount = 1;

				@Override
				public int[] get() {
					int[] result = new int[outputLenCount];
					for (int i = 0; i < outputLenCount; i++) {
						result[i] = supp.get();
					}
	
					++outputLenCount;
	
					return result;
				}
		};

		Function<Supplier<Integer>, Supplier<int[]>> f10v3 =
				supp -> new Supplier<>() {
					int outputLenCount = 1;

					@Override
					public int[] get() {
						int[] result = IntStream.range(0, outputLenCount)
							.map(n -> supp.get())
							.toArray();
		
						++outputLenCount;
		
						return result;
					}
			};
			
		Function<Supplier<Integer>, Supplier<int[]>> f10v4 =
			supp -> new Supplier<>() {
				int outputLenCount = 1;

				@Override
				public int[] get() {
					int[] result = Stream.generate(supp)
						.limit(outputLenCount)
						.mapToInt(i -> i)
						.toArray();
					
					++outputLenCount;
	
					return result;
				}
		};
				
		Supplier<Integer> origSupp = intsSupplier();
		Supplier<int[]> grpSuppV1 = f10.apply(origSupp);
		Supplier<int[]> grpSuppV2 = f10v2.apply(origSupp);
		Supplier<int[]> grpSuppV3 = f10v3.apply(origSupp);
		Supplier<int[]> grpSuppV4 = f10v4.apply(origSupp);
		
		System.out.println(Arrays.toString(grpSuppV1.get()));
		System.out.println(Arrays.toString(grpSuppV1.get()));
		System.out.println(Arrays.toString(grpSuppV1.get()));
		System.out.println(Arrays.toString(grpSuppV1.get()));

		System.out.println("--------------");

		System.out.println(Arrays.toString(grpSuppV2.get()));
		System.out.println(Arrays.toString(grpSuppV2.get()));
		System.out.println(Arrays.toString(grpSuppV2.get()));
		System.out.println(Arrays.toString(grpSuppV2.get()));

		System.out.println("--------------");

		System.out.println(Arrays.toString(grpSuppV3.get()));
		System.out.println(Arrays.toString(grpSuppV3.get()));
		System.out.println(Arrays.toString(grpSuppV3.get()));
		System.out.println(Arrays.toString(grpSuppV3.get()));
		
		System.out.println("--------------");
		
		System.out.println(Arrays.toString(grpSuppV4.get()));
		System.out.println(Arrays.toString(grpSuppV4.get()));
		System.out.println(Arrays.toString(grpSuppV4.get()));
		System.out.println(Arrays.toString(grpSuppV4.get()));

		System.out.println("--------------");

		System.out.println(Arrays.toString(grpSuppV1.get()));
		System.out.println(Arrays.toString(grpSuppV1.get()));
		System.out.println(Arrays.toString(grpSuppV1.get()));
		System.out.println(Arrays.toString(grpSuppV1.get()));

		System.out.println("--------------");
		
		Integer id = id(1);
		String id2 = id("abc");
		Integer id3 = Gyakorlat.<Integer>id(3);
	}

	public static <T> T id(T t) { return t; }
	
	public static <T> Function<Supplier<T>, Supplier<List<T>>>
		makeGroupSupplier() {

		return supp -> new Supplier<>() {
			int outputLenCount = 1;

			@Override
			public List<T> get() {
				List<T> result = Stream.generate(supp)
					.limit(outputLenCount)
					.collect(Collectors.toList());

				++outputLenCount;

				return result;
			}
		};
	}
	
	
	
	private static Supplier<Integer> intsSupplier() {
		return new Supplier<Integer>() {
			int idx = 0;
			
			@Override
			public Integer get() {
				++idx;
				return idx;
			}
		};
	}
}
