import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.IntSummaryStatistics;
import java.util.List;
import java.util.Optional;
import java.util.OptionalInt;
import java.util.function.IntUnaryOperator;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class Lambda2 {
	public static void main(String[] args) {
		Supplier<String> si = String::new;

		@SuppressWarnings({ "deprecation", "unused" })
		IntUnaryOperator io = Integer::new;

		Supplier<MyData> md = MyData::new;


		
		int result1 = IntStream.rangeClosed(1, 10)
				.reduce(100, (i, j) -> i + j);
		System.out.println(result1);

		int result2 = IntStream.rangeClosed(1, 10)
				.reduce(1, (i, j) -> i * j);
		System.out.println(result2);
		
		// Cannot infer type argument(s) for <T> of(T[])
		IntUnaryOperator op =
			Stream.<IntUnaryOperator>of(i -> i + 1, i -> 3 * i + 1)
				.reduce((f, g) -> g.compose(f))
				.get();
		IntUnaryOperator op2 =
			Stream.<IntUnaryOperator>of(i -> 3 * i + 1, i -> i + 1)
				.reduce((f, g) -> g.compose(f))
				.get();

		System.out.println(op.applyAsInt(100));
		System.out.println(op2.applyAsInt(100));

	
		IntSummaryStatistics stat =
			IntStream.rangeClosed(1, 10).summaryStatistics();
		System.out.println(stat);
	}
}

class MyData {}










interface Abc {
	int f();
	public abstract int f2();

	final static int a = 4;
	
	// default
	// static
}

abstract class Abc2 {
	int f() {
		return 0;
	}
	public abstract int f2();
}


interface Shape {
	double getArea();

	static double getAreas(Shape[] shapes) {
		Stream<Integer> boxed = IntStream.of(1,2,3).boxed();
		
		return Arrays.stream(shapes)
				.map(Shape::getArea)
				// .unboxed()
//				.mapToDouble(d -> d)
				.mapToDouble(Double::doubleValue)
				.sum();
	}
}



class Valami
{
	public static void main(String[] args) {
		int[] array = new int[] {1,2,3};
		System.out.println(array);
		System.out.println(Arrays.toString(array));

		Arrays.sort(array);
		System.out.println(Arrays.toString(array));


		
		List<Integer> list = new ArrayList<>();
		list.add(1);
		list.add(2);
		list.add(3);

		Collections.sort(list);
		System.out.println(list);

		list.sort((i, j) -> j - i);
		System.out.println(list);

	
		OptionalInt result = IntStream.of().findFirst();
		System.out.println(result);

		OptionalInt opt1 = OptionalInt.empty();
		OptionalInt opt2 = OptionalInt.of(123);

		if (OptionalInt.empty() == opt1) {
			System.out.println("is empty");
		}
		
		if (OptionalInt.empty() != opt2) {
			System.out.println("is not empty");
		}

//		int asInt = opt1.getAsInt();

//		int result3 = IntStream.of().findFirst().getAsInt();

		Supplier<Integer> supp = () -> 543;
		
		Optional<Integer> opt3 = Optional.of(123);
		Optional<Integer> opt4 = Optional.empty();
		Object opt5 = Optional.empty().orElse(234);
		Object result6 = Optional.empty().orElseGet(supp);
		
		boolean present = opt4.isPresent();

	
		Stream.iterate(1, i -> i + 1)
			.flatMap(i -> IntStream.rangeClosed(1, i).boxed())
			.limit(100)
			.forEach(System.out::println);
		
		// The method collect(Collector<? super Integer,A,R>)
		// in the type Stream<Integer> is not applicable
		// for the arguments (Collector<CharSequence,capture#1-of ?,String>)
		String result7 = Stream.iterate(1, i -> i + 1)
		.flatMap(i -> IntStream.rangeClosed(1, i).boxed())
		.limit(100)
//		.map(Integer::toString)
		.map(i -> "" + i)
		.collect(Collectors.joining(", "));

		System.out.println(result7);

		list.parallelStream();
	
	}
}




class Ido {
	public static void main(String[] args) {
		int result1 = IntStream.rangeClosed(1,40000000).parallel().sum();
//		int result1 = IntStream.rangeClosed(1,40000000).sum();
		System.out.println(result1);
	}
}



